sr=44100
kr=441
ksmps=100
nchnls=2

	instr 3	;simple fm 2:1
ipch 	= p4
ipch2	= p5

if p4 > 15 igoto pchPass
  ipch 	= cpspch(p4)
pchPass:

if p5 > 15 igoto pch2Pass
  ipch2 	= cpspch(p5)
pch2Pass:

kpchline 	line ipch, p3, ipch2

iamp 	= ampdb(p6)
iSpace	= p7
ienvType	= p8

itable	= 4

kenv 	init 	0

if ienvType == 0 kgoto env0  ; adsr
if ienvType == 1 kgoto env1  ; pyramid
if ienvType == 2 kgoto env2  ; ramp

env0:

	kenv	adsr	.3, .2, .9, .5

	kgoto endEnvelope

env1:
	
	kenv 	linseg	0, p3 * .5, 1, p3 * .5, 0

	kgoto endEnvelope

env2:
	
	kenv	linseg 	0, p3 - .1, 1, .1, 0	

	kgoto endEnvelope

endEnvelope:


icar	= 2
imod	= 1

aout	foscili  	iamp * kenv, kpchline, icar, imod, kenv, 1



krtl     	= sqrt(2) / 2 * cos(iSpace) + sin(iSpace) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * cos(iSpace) - sin(iSpace)	; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

	outs aLeft, aRight

	endin

	instr 4	;simple fm 1:1
ipch 	= p4
ipch2	= p5

if p4 > 15 igoto pchPass
  ipch 	= cpspch(p4)
pchPass:

if p5 > 15 igoto pch2Pass
  ipch2 	= cpspch(p5)
pch2Pass:

kpchline 	line ipch, p3, ipch2

iamp 	= ampdb(p6)
iSpace	= p7
ienvType	= p8

itable	= 4

kenv 	init 	0

if ienvType == 0 kgoto env0  ; adsr
if ienvType == 1 kgoto env1  ; pyramid
if ienvType == 2 kgoto env2  ; ramp

env0:

	kenv	adsr	.3, .2, .9, .5

	kgoto endEnvelope

env1:
	
	kenv 	linseg	0, p3 * .5, 1, p3 * .5, 0

	kgoto endEnvelope

env2:
	
	kenv	linseg 	0, p3 - .1, 1, .1, 0	

	kgoto endEnvelope

endEnvelope:


icar	= 1
imod	= 1

aout	foscili  	iamp * kenv, kpchline, icar, imod, kenv, 1



krtl     	= sqrt(2) / 2 * cos(iSpace) + sin(iSpace) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * cos(iSpace) - sin(iSpace)	; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

	outs aLeft, aRight

	endin
